//EXAMPLE5 JOB  'JAY MOSELEY',CLASS=A,MSGLEVEL=(1,1),REGION=512K
//ASMFC    EXEC ASMFC,PARM.ASM='LIST,LOAD,NODECK,NOXREF'
//ASM.SYSUT1 DD UNIT=SYSDA
//ASM.SYSUT2 DD UNIT=SYSDA
//ASM.SYSUT3 DD UNIT=SYSDA
//ASM.SYSGO  DD DSN=&&ALCOBJ,DISP=(NEW,PASS),
//             UNIT=SYSDA,SPACE=(TRK,(9,9),RLSE)
//ASM.SYSIN DD  *
         TITLE 'EXAMPLE5 - BUILD SORT NAME FOR RPG MAIN PROGRAM'        00010000
* ******************************************************************* * 00020000
* ******************************************************************* * 00030000
*                                                                     * 00040000
* THIS SUBROUTINE SCANS A NAME FIELD PASSED TO IT BY THE CALLING      * 00050000
* RPG MAIN PROGRAM - THE FORMAT OF THE FIELD PASSED IS ASSUMED TO     * 00060000
* BE: FIRST I. LAST - AND REVERSES THE ORDER OF THE FIELD ELEMENTS    * 00070000
* TO CONSTRUCT A NAME SUITABLE FOR SORTING IN ORDER TO PLACE THE      * 00080000
* NAME INTO ALPHABETICAL SEQUENCE ON THE SURNAME (LAST) PORTION OF    * 00090000
* THE FIELD - LAST, FIRST I                                           * 00100000
*                                                                     * 00110000
* NO VERIFICATION OF THE FIELD IS PERFORMED BY THIS ROUTINE SINCE     * 00120000
* THIS IS INTENDED AS AN ILLUSTRATION OF CALLING A SUBROUTINE BY AN   * 00130000
* RPG PROGRAM                                                         * 00140000
*                                                                     * 00150000
* THE CALLING PROGRAM SHOULD USE THE FOLLOWING SYNTAX:                * 00160000
*                                                                     * 00170000
*     .-OPERATION   .-FACTOR 2   .-RESULT   .-LENGTH                  * 00180000
*     EXIT          EX5SUB                                            * 00190000
*     RLABL                      FULLNAME   35                        * 00200000
*     ULABL                      SORTNAME   35                        * 00210000
*                                                                     * 00220000
* ******************************************************************* * 00230000
* ******************************************************************* * 00240000
*                                                                       00250000
EX5SUB   CSECT                                                          00260000
*                                                                       00290000
         ENTRY SNAME                   MAKE SNAME VISABLE TO RPG        00290010
*                                                                       00290020
         PRINT NOGEN                                                    00300000
         SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00310000
*                                                                       00320000
         BALR  R12,0                   ESTABLISH BASE REGISTER          00330000
         USING *,R12                   ASSUME BASE REGISTER             00340000
*                                                                       00350000
         L     R10,=V(NAME)            LOAD ADDRESS OF RPG FIELD        00360000
*                                                                       00370000
         LA    R3,34(,R10)             STARTING AT END OF NAME          00380000
*                                                                       00390000
LOOP1    CLI   0(R3),C' '              LOOK FOR NON-BLANK               00400000
         BNE   CONT1                   FOUND, NEXT STEP                 00410000
         BCT   R3,LOOP1                CONTINUE LOOPING                 00420000
*                                                                       00430000
CONT1    LA    R4,1(,R3)               A(LAST NAME ENDS)                00440000
*                                                                       00450000
LOOP2    CLI   0(R3),C' '              LOOKING FOR BLANK                00460000
         BE    CONT2                   FOUND, NEXT STEP                 00470000
         BCT   R3,LOOP2                CONTINUE LOOPING                 00480000
*                                                                       00490000
CONT2    LA    R5,1(,R3)               A(LAST NAME BEGINS)              00500000
*                                                                       00510000
LOOP3    CLI   0(R3),C'.'              LOOKING FOR PERIOD               00520000
         BE    CONT3                   FOUND, NEXT STEP                 00530000
         BCT   R3,LOOP3                CONTINUE LOOPING                 00540000
*                                                                       00550000
CONT3    BCTR  R3,0                    MOVE BEYOND PERIOD               00560000
         LR    R6,R3                   A(INITIAL)                       00570000
*                                                                       00580000
         MVI   SNAME,C' '              CLEAR OUTPUT FIELD               00590000
         MVC   SNAME+1(L'SNAME-1),SNAME  TO SPACES                      00600000
*                                                                       00610000
         LR    R1,R4                   A(LAST NAME END)                 00620000
         SR    R1,R5                   SUBTRACT A(LAST NAME BEG)        00630000
         EX    R1,MOVELAST             MOVE LAST NAME                   00640000
MOVELAST MVC   SNAME(*-*),0(R5)        ** EXECUTED **                   00650000
*                                                                       00660000
         LA    R11,SNAME(R1)           A(TO PLACE COMMA)                00660010
         MVI   0(R11),C','             INSERT COMMA                     00670000
         LA    R11,2(,R11)             INCREASE FOR COMMA + SPACE       00680000
*                                                                       00700000
         LR    R1,R6                   A(INITIAL)                       00710000
         SR    R1,R10                  SUBTRACT A(NAME BEG)             00720000
         EX    R1,MOVEREST             MOVE FIRST/INITIAL               00730000
MOVEREST MVC   0(*-*,R11),0(R10)       ** EXECUTED **                   00740000
*                                                                       00750000
*    RETURN TO CALLER WITH ZERO RETURN CODE                             00760000
*                                                                       00770000
         RETURN (14,12),RC=0                                            00780000
*                                                                       00790000
* ******************************************************************* * 00800000
* *************************** VARIABLES ***************************** * 00810000
* ******************************************************************* * 00820000
*                                                                       00820010
SNAME    DS    CL35                    CONTAINER FOR SORT NAME          00820020
         LTORG                                                          00830000
         EJECT                                                          00840000
* ******************************************************************* * 00850000
* ***************************** EQUATES ***************************** * 00860000
* ******************************************************************* * 00870000
R0       EQU   0                                                        00880000
R1       EQU   1                                                        00890000
R2       EQU   2                                                        00900000
R3       EQU   3                                                        00910000
R4       EQU   4                                                        00920000
R5       EQU   5                                                        00930000
R6       EQU   6                                                        00940000
R7       EQU   7                                                        00950000
R8       EQU   8                                                        00960000
R9       EQU   9                                                        00970000
R10      EQU   10                                                       00980000
R11      EQU   11                                                       00990000
R12      EQU   12                                                       01000000
R13      EQU   13                                                       01010000
R14      EQU   14                                                       01020000
R15      EQU   15                                                       01030000
         END                                                            01040000
/*
//RPGCLG   EXEC RPGECLG,COND.LKED=(9,LT,RPG)
//RPG.SYSUT3 DD UNIT=SYSDA
//RPG.SYSUT2 DD UNIT=SYSDA
//RPG.SYSUT1 DD UNIT=SYSDA
//RPG.SYSGO DD  UNIT=SYSDA
//RPG.SYSIN DD  *
     H
     H*
     H* BUILD FILE TO PRODUCE CLASS ROSTER REPORT
     H*
     FSTMASTR IPE F 250 250  7KI     2 DISK14       S
     FROSTER  O   F4800  48            DISK14       S
     FREPORT  O   F 132 132           LPRINTER
     LREPORT    101 6012
     ISTMASTR AA  01   1 CA
     I       OR   02   1NCA
     I                                        2   8 IDENT
     I                                        9  43 NAME
     I                                      136 1410CN1N            11
     I                                      136 141 CN1
     I                                      145 1500CN2N            12
     I                                      145 150 CN2
     I                                      154 1590CN3N            13
     I                                      154 159 CN3
     I                                      163 1680CN4N            14
     I                                      163 168 CN4
     I                                      172 1770CN5N            15
     I                                      172 177 CN5
     I                                      181 1860CN6N            16
     I                                      181 186 CN6
     I                                      190 1950CN7N            17
     I                                      190 195 CN7
     I                                      199 2040CN8N            18
     I                                      199 204 CN8
     C*
     C* CALL ASSEMBLER SUBROUTINE TO BUILD SORT NAME
     C*
     C   01                MOVE ' '       SNAME  35
     C   01                EXIT EX5SUB
     C                     RLABL          NAME   35
     C                     ULABL          SNAME  35
     C*
     C* COUNT STUDENT RECORDS AND RECORDS WRITTEN
     C*
     C   01      STCNT     ADD  1         STCNT   30
     C   01N11   OUTCNT    ADD  1         OUTCNT  30
     C   01N12   OUTCNT    ADD  1         OUTCNT
     C   01N13   OUTCNT    ADD  1         OUTCNT
     C   01N14   OUTCNT    ADD  1         OUTCNT
     C   01N15   OUTCNT    ADD  1         OUTCNT
     C   01N16   OUTCNT    ADD  1         OUTCNT
     C   01N17   OUTCNT    ADD  1         OUTCNT
     C   01N18   OUTCNT    ADD  1         OUTCNT
     OROSTER  D        01N11
     O                         SNAME     48
     O                         IDENT     13
     O                         CN1        6
     O        D        01N12
     O                         SNAME     48
     O                         IDENT     13
     O                         CN2        6
     O        D        01N13
     O                         SNAME     48
     O                         IDENT     13
     O                         CN3        6
     O        D        01N14
     O                         SNAME     48
     O                         IDENT     13
     O                         CN4        6
     O        D        01N15
     O                         SNAME     48
     O                         IDENT     13
     O                         CN5        6
     O        D        01N16
     O                         SNAME     48
     O                         IDENT     13
     O                         CN6        6
     O        D        01N17
     O                         SNAME     48
     O                         IDENT     13
     O                         CN7        6
     O        D        01N18
     O                         SNAME     48
     O                         IDENT     13
     O                         CN8        6
     OREPORT  H  201   1P
     O                                   33 'RECORD EXTRACT'
     O                                   19 'COURSE ROSTER '
     O        T 32     LR
     O                         STCNT Z    7
     O                                   24 'STUDENT RECORDS '
     O                                   28 'READ'
     O        T  1     LR
     O                         OUTCNTZ    7
     O                                   23 'ROSTER RECORDS '
     O                                   30 'WRITTEN'
/*
//LKED.SYSIN  DD *
  INCLUDE ALCMOD
/*
//LKED.ALCMOD DD DSN=&&ALCOBJ,DISP=OLD
//LKED.SYSLIB DD DSN=SYS1.MACLIB,DISP=SHR
//GO.SYSUDUMP DD SYSOUT=A
//GO.STMASTR DD DSN=JAY.STMAST,DISP=OLD,DCB=DSORG=IS
//GO.ROSTER  DD DSN=CLASS.ROSTER,DISP=(NEW,KEEP),
//             UNIT=2314,VOL=SER=TSO001,
//             SPACE=(CYL,(2,2),RLSE)
//GO.REPORT  DD SYSOUT=A
//IEBPTPCH EXEC PGM=IEBPTPCH,REGION=128K
//SYSIN    DD  *
  PRINT MAXFLDS=1
  RECORD FIELD=(48)
/*
//SYSPRINT DD  SYSOUT=A
//SYSUT1   DD  DSN=CLASS.ROSTER,UNIT=2314,VOL=SER=TSO001,DISP=OLD
//SYSUT2   DD  SYSOUT=A
//
